{% extends "users/userspace.html" %}

{% load template_utils %}

{% block additional_stylesheets %}
<style>
    .form-control[readonly] {
        background-color: rgba(234,236,239,0.4);
    }
</style>
{% endblock %}

{% block content %}
    <div class="container py-4">
        <h1>S'inscrire à des distributions</h1>
        <h5>Choix des produits</h5>

        <form action="" method="post">
            {% csrf_token %}

            <div class="w-100 d-flex justify-content-between my-3">
                <a href="{% url 'my_contrats' %}" class="btn btn-secondary">
                    Retour
                </a>

                <button type="submit" class="btn btn-success">
                    Continuer
                </button>
            </div>
            {{ PAGE_NOUVEAU_CONTRAT|safe }}
            {%if distrib_unique %}
            <div class="fst-italic mb-3 alert alert-primary">
                Vous êtes actuellement sur la page de la distribution spéciale du {{ distrib_unique.date_heure|date:"d/m/Y" }}.
                Pour retrouver toutes les autres distributions, <a href="{% url 'register_adherent_distributions' %}" class="link-dark">cliquez ici</a>.
            </div>
            {% endif %}
            {%if not is_adherent and not essai_gratuit %}
            <div class="fst-italic mb-3 alert alert-warning">
                Les produits dont les dates sont marquées d'une astérisque (*) ne nécessitent pas d'être adhérent.e pour
                s'inscrire.
                <a href="{% url 'register_adhesion' %}" target="_blank" class="link-dark">Cliquez ici pour adhérer.</a>
            </div>
            {% endif %}
            {%if not is_adherent and essai_gratuit %}
            <div class="fst-italic mb-3 alert alert-primary">
                En tant que non-adhérent.e, vous avez accès à un essai gratuit. Celui-ci vous permet de vous inscrire à une formule 4 distributions.
                <a href="{% url 'register_adhesion' %}" target="_blank" class="link-dark">Cliquez ici pour adhérer.</a>
            </div>
            {% endif %}
            {%if produits_par_ferme|length == 0 %}
            <div class="mb-3 fw-bold alert alert-warning">
                <i class="fas fa-exclamation-circle me-2"></i> Aucun produit n'est actuellement disponible. Merci de réessayer ultérieurement.
            </div>
            {% endif %}

            {% if form.errors %}
                <div class="alert alert-danger" role="alert">
                    {% for fieldname, errors in form.errors.items %}
                        {% if fieldname == "__all__" %}
                            Problèmes :
                        {% else %}
                            {{ fieldname }} :
                        {% endif %}
                        <ul>
                            {% for error in errors %}
                                <li>{{ error | safe }}</li>
                            {% endfor %}
                        </ul>
                    {% endfor %}
                </div>
            {% endif %}
            {% for ferme in fermes %}
                <article class="mb-5">
                    <h2>Ferme : {{ ferme.nom }}</h2>
                    <i class="ms-2 fs-5">Production de {{ ferme.type_activite }}</i>
                    {% if ferme.infos_commande %}
                    <div class="m-2 fs-5"><i class="fas fa-stopwatch me-2"></i>{{ ferme.infos_commande }}</div>
                    {% endif %}
                    <section>
                        {% for produit in produits_par_ferme|get_item:ferme.id %}
                        {% with inscriptions_frequences=distributions_par_frequences_par_produit|get_item:produit.id %}
                            <article class="border rounded p-4 my-3 mx-2">
                                <div class="hand-cursor d-flex flex-row align-items-center"
                                     id="produit_toggler_{{ produit.id }}"
                                >
                                    <i class="fas fa-angle-down me-4 fs-2 toggle-icon"></i>
                                    <div class="d-flex flex-row flex-wrap me-5">
                                        <h3 class="hand-cursor d-flex flex-row flex-wrap justify-content-between w-100">
                                            {{ produit.nom }}
                                        </h3>
                                        {% if produit.description %}
                                            <i class="fs-5 mt-0" style="word-break: break-word">
                                                {{ produit.description }}
                                            </i>
                                        {% endif %}
                                    </div>

                                    <span class="ms-auto fs-3" style="flex-shrink: 0">
                                        TOTAL :
                                        <span id="produit_{{ produit.id }}_total">0.0</span> €
                                    </span>
                                </div>

                                <section class="hidden px-3 mt-3" id="produit_{{ produit.id }}_list">
                                    <hr>
                                    <ul class="list-unstyled">
                                        
                                        <li>
                                            <input type="radio" id="produit_{{ produit.id }}_radio_none" class="form-check-input produit-{{ produit.id }}-frequences" name="choice_{{ produit.id }}" checked/>
                                            <label class="form-check-label" for="produit_{{ produit.id }}_radio_none">Ne rien commander</label>
                                        </li>

                                        {% if "unique" in produit.frequences and inscriptions_frequences|get_item:"unique"|length > 0 %} 
                                        <li>
                                            <input type="radio" id="produit_{{ produit.id }}_radio_unique" class="form-check-input produit-{{ produit.id }}-frequences" name="choice_{{ produit.id }}" />
                                            <label class="form-check-label" for="produit_{{ produit.id }}_radio_unique">Livraison unique</label>
                                        </li>
                                        {% endif %}
                                        
                                        {% if not distrib_unique and "hebdomadaire_4" in produit.frequences and inscriptions_frequences|get_item:"hebdomadaire_4"|length > 0 %}
                                        <li>
                                            <input type="radio" id="produit_{{ produit.id }}_radio_hebdomadaire_4" class="form-check-input produit-{{ produit.id }}-frequences" name="choice_{{ produit.id }}" {% if not is_adherent and not essai_gratuit %}disabled{% endif %} />
                                            <label class="form-check-label" for="produit_{{ produit.id }}_radio_hebdomadaire_4">Livraison hebdomadaire pour 4 distributions</label>
                                        </li>
                                        {% endif %}

                                        {% if not distrib_unique and "hebdomadaire_semestre" in produit.frequences and inscriptions_frequences|get_item:"hebdomadaire_semestre"|length > 0 %}
                                        <li>
                                            <input type="radio" id="produit_{{ produit.id }}_radio_hebdomadaire_semestre" class="form-check-input produit-{{ produit.id }}-frequences" name="choice_{{ produit.id }}" {% if not is_adherent %}disabled{% endif %} />
                                            <label class="form-check-label" for="produit_{{ produit.id }}_radio_hebdomadaire_semestre">Livraison hebdomadaire pour tout le semestre</label>
                                        </li>
                                        {% endif %}

                                        {% if not distrib_unique and "bimensuelle_4" in produit.frequences and inscriptions_frequences|get_item:"bimensuelle_4"|length > 0 %}
                                        <li>
                                            <input type="radio" id="produit_{{ produit.id }}_radio_bimensuelle_4" class="form-check-input produit-{{ produit.id }}-frequences" name="choice_{{ produit.id }}" {% if not is_adherent and not essai_gratuit %}disabled{% endif %} />
                                            <label class="form-check-label" for="produit_{{ produit.id }}_radio_bimensuelle_4">Livraison une distribution sur deux pour 4 distributions</label>
                                        </li>
                                        {% endif %}

                                        {% if not distrib_unique and "bimensuelle_semestre" in produit.frequences and inscriptions_frequences|get_item:"bimensuelle_semestre"|length > 0 %}
                                        <li>
                                            <input type="radio" id="produit_{{ produit.id }}_radio_bimensuelle_semestre" class="form-check-input produit-{{ produit.id }}-frequences" name="choice_{{ produit.id }}" {% if not is_adherent %}disabled{% endif %}/>
                                            <label class="form-check-label" for="produit_{{ produit.id }}_radio_bimensuelle_semestre">Livraison une distribution sur deux pour tout le semestre</label>
                                        </li>
                                        {% endif %}

                                        <li id="produit_{{ produit.id }}_quantity_li"class="d-flex flew-row flex-nowrap me-5 align-items-center">
                                            <label for="produit_{{ produit.id }}_quantity" class="me-2">Quantité par distribution : </label>
                                            <input type="number" id="produit_{{ produit.id }}_quantity" class="form-control" style="width: 5em; direction: rtl" value="0" min="0" max="{{ commande_max }}"/>
                                        </li>

                                    </ul>
                                    <hr id="produit_{{ produit.id }}_hr" class="">
                                    <ul class="list-unstyled">
                                        {% for inscription in inscriptions_par_produit|get_item:produit.id %}
                                            <li id ="distribution_{{ inscription.distribution.id }}_produit_{{ produit.id }}_li" class="d-flex flex-row flex-wrap align-items-center my-2 {% if not inscription.adhesion_requise and not is_adherent and not essai_gratuit %} fst-italic{% endif %}">
                                                {% if not inscription.adhesion_requise and not is_adherent and not essai_gratuit %}
                                                    *
                                                {% endif %}
                                                <label for="distribution_{{ inscription.distribution.id }}_produit_{{ produit.id }}"
                                                       class="me-3"
                                                >
                                                    {{ inscription.distribution.date_heure|date:"d/m/Y" }}
                                                    {{ inscription.distribution.date_heure|date:"H:i" }}
                                                    - {{ inscription.distribution.date_heure_fin|date:"H:i" }}
                                                </label>

                                                <div class="d-flex flew-row flex-nowrap me-5 align-items-center">
                                                    <input type="number" min="0" max="{{ commande_max|mini:inscription.unites_restantes }}"
                                                           id="distribution_{{ inscription.distribution.id }}_produit_{{ produit.id }}"
                                                           name="distribution_{{ inscription.distribution.id }}_produit_{{ produit.id }}"
                                                           style="width: 5em; direction: rtl"
                                                           class="me-2 form-control produit-{{ produit.id }}-count "
                                                           
                                                    />
                                                    x {{ inscription.quantite_unitaire }}
                                                    (max. {{ commande_max|mini:inscription.unites_restantes }})
                                                </div>

                                                <div class="d-flex flex-row flex-nowrap align-items-center">
                                                    <span class="me-2">Montant :</span>
                                                    <span id="tarif_{{ inscription.id }}_qt">0</span>
                                                    <span class="mx-2"> x {{ inscription.tarif_vente }} € = </span>
                                                    <span id="tarif_{{ inscription.id }}">0,0 €</span>
                                                </div>
                                            </li>
                                        {% endfor %}
                                    </ul>
                                </section>
                            </article>
                        {% endwith %}
                        {% endfor %}
                    </section>
                </article>
            {% endfor %}

            <div class="w-100 d-flex justify-content-between mt-5">
                <a href="{% url 'my_contrats' %}" class="btn btn-secondary">
                    Retour
                </a>

                <button type="submit" class="btn btn-success">
                    Continuer
                </button>
            </div>
        </form>
    </div>
{% endblock %}

{% block scripts %}
    <script>
        function toggle_dropdown(produit_id) {
            let dropdown = $("#produit_" + produit_id + "_list");
            let toggler_icon = $("#produit_toggler_" + produit_id + " .toggle-icon");
            if (dropdown.hasClass("hidden")) {
                dropdown.removeClass("hidden");
                toggler_icon.removeClass("fa-angle-down");
                toggler_icon.addClass("fa-angle-up");
            } else {
                dropdown.addClass("hidden");
                toggler_icon.removeClass("fa-angle-up");
                toggler_icon.addClass("fa-angle-down");
            }
        }

        function compute_total_price(input_ids, prices) {
            let total = 0.0;
            for (let i = 0; i < input_ids.length; i++) {
                let amount = $("#" + input_ids[i]).val();
                total += amount * prices[i];
            }
            return total;
        }
    </script>

    <script>
        {% for ferme in fermes %}
            {% for produit in produits_par_ferme|get_item:ferme.id %}
            {% with inscriptions_frequences=distributions_par_frequences_par_produit|get_item:produit.id %}
            {   
                // Local variables for each produit
                let amount_inputs_ids_{{ produit.id }} = []; // Array of input ids
                let individual_prices_{{ produit.id }} = []; // Array of prices
                
                // Toggler
                let toggler = $("#produit_toggler_{{ produit.id }}"); 

                // Radio buttons
                let radio_none = $("#produit_{{ produit.id }}_radio_none"); 
                let radio_hebdomadaire_4 = $("#produit_{{ produit.id }}_radio_hebdomadaire_4");
                let radio_hebdomadaire_semestre = $("#produit_{{ produit.id }}_radio_hebdomadaire_semestre");
                let radio_bimensuelle_4 = $("#produit_{{ produit.id }}_radio_bimensuelle_4");
                let radio_bimensuelle_semestre = $("#produit_{{ produit.id }}_radio_bimensuelle_semestre");
                let radio_unique = $("#produit_{{ produit.id }}_radio_unique");

                let quantity = $("#produit_{{ produit.id }}_quantity"); // Quantity input
                let quantity_li = $("#produit_{{ produit.id }}_quantity_li"); // Quantity input + label
                let horizontal_bar = $("#produit_{{ produit.id }}_hr"); // Horizontal bar

                let produit_distribution_quantities = $(".produit-{{ produit.id }}-count"); // All distribution quantities inputs

                toggler.click(() => {
                    toggle_dropdown({{ produit.id }});
                });

                // Globals events for each produit

                // Quantity
                quantity.change(() => {
                    $(".produit-{{ produit.id }}-frequences:checked").trigger("change");
                });

                // None
                radio_none.change(() => {
                    if(radio_none.prop("checked")) {
                        horizontal_bar.addClass("d-none");
                        quantity_li.addClass("d-none");
                        produit_distribution_quantities.val("0").trigger("change");
                        produit_distribution_quantities.prop("readonly", true);
                    }
                });

                // Unique
                {% if "unique" in produit.frequences and inscriptions_frequences|get_item:"unique"|length > 0 %}
                radio_unique.change(() => {
                    if(radio_unique.prop("checked")) {
                        horizontal_bar.removeClass("d-none");
                        quantity_li.addClass("d-none");
                    }
                });
                {% endif %}

                // Hebdomadaire 4
                {% if not distrib_unique and "hebdomadaire_4" in produit.frequences and inscriptions_frequences|get_item:"hebdomadaire_4"|length > 0 %}
                {% if essai_gratuit or is_adherent %}
                radio_hebdomadaire_4.change(() => {           
                    if(radio_hebdomadaire_4.prop("checked")) {
                        horizontal_bar.removeClass("d-none");
                        quantity_li.removeClass("d-none");
                        produit_distribution_quantities.prop("readonly", true);
                    }
                });
                {% endif %}
                {% endif %}

                // Hebdomadaire Semestre
                {% if not distrib_unique and "hebdomadaire_semestre" in produit.frequences and inscriptions_frequences|get_item:"hebdomadaire_semestre"|length > 0 %}
                {% if is_adherent %}
                radio_hebdomadaire_semestre.change(() => {
                    if(radio_hebdomadaire_semestre.prop("checked")) {
                        horizontal_bar.removeClass("d-none");
                        quantity_li.removeClass("d-none");
                        produit_distribution_quantities.prop("readonly", true);
                    }
                });
                {% endif %}
                {% endif %}

                // Bimensuelle 4
                {% if not distrib_unique and "bimensuelle_4" in produit.frequences and inscriptions_frequences|get_item:"bimensuelle_4"|length > 0 %}
                {% if essai_gratuit or is_adherent %}
                radio_bimensuelle_4.change(() => {
                    if(radio_bimensuelle_4.prop("checked")) {
                        horizontal_bar.removeClass("d-none");
                        quantity_li.removeClass("d-none");
                        produit_distribution_quantities.prop("readonly", true);
                    }
                });
                {% endif %}
                {% endif %}
                    
                // Bimensuelle Semestre
                {% if not distrib_unique and "bimensuelle_semestre" in produit.frequences and inscriptions_frequences|get_item:"bimensuelle_semestre"|length > 0 %}
                {% if is_adherent %}
                radio_bimensuelle_semestre.change(() => {
                    if(radio_bimensuelle_semestre.prop("checked")) {
                        horizontal_bar.removeClass("d-none");
                        quantity_li.removeClass("d-none");
                        produit_distribution_quantities.prop("readonly", true);
                    }
                });
                {% endif %}
                {% endif %}

                {% for inscription in inscriptions_par_produit|get_item:produit.id %}
                {
                    // Local variables for each inscription

                    // Quantity input
                    let distribution_quantity = $("#distribution_{{ inscription.distribution.id }}_produit_{{ produit.id }}");
                    // Quantity input + label
                    let distribution_quantity_li = $("#distribution_{{ inscription.distribution.id }}_produit_{{ produit.id }}_li");

                    distribution_quantity.change(
                        () => {
                            let amount = distribution_quantity.val();
                            let price_amount_display = $("#tarif_{{ inscription.id }}_qt");
                            let price = parseFloat("{{ inscription.tarif_vente }}".replace(",", ".")) * amount;
                            $("#tarif_{{ inscription.id }}").text(
                                price.toFixed(2) + " €"
                            );
                            if (amount !== "") {
                                $(price_amount_display).text(
                                    amount
                                );
                            } else {
                                $(price_amount_display).text(
                                    "0"
                                );
                            }
                            let total_price = compute_total_price(
                                amount_inputs_ids_{{ produit.id }}, individual_prices_{{ produit.id }}
                            );
                            $("#produit_{{ produit.id }}_total").text(total_price.toFixed(2));
                        }
                    );

                    amount_inputs_ids_{{ produit.id }}.push("distribution_{{ inscription.distribution.id }}_produit_{{ produit.id }}");
                    individual_prices_{{ produit.id }}.push(parseFloat("{{ inscription.tarif_vente }}".replace(",", ".")));
                    
                    // Globals events for each inscription

                    // None
                    radio_none.change(() => {
                        if(radio_none.prop("checked")) {
                            distribution_quantity_li.addClass("d-none");
                        }
                    });

                    // Unique
                    {% if "unique" in produit.frequences and inscriptions_frequences|get_item:"unique"|length > 0 %}
                    radio_unique.change(() => {
                        if(radio_unique.prop("checked")) {
                            {% if inscription.livraison_unique and inscription|is_allowed:request.user %}
                                distribution_quantity_li.removeClass("d-none");
                                distribution_quantity.prop("readonly", false);
                            {% elif inscription.livraison_unique %}
                                distribution_quantity_li.removeClass("d-none");
                                distribution_quantity.prop("readonly", true);
                                distribution_quantity.val("0").trigger("change");
                            {% else %}
                                distribution_quantity.prop("readonly", true);
                                distribution_quantity_li.addClass("d-none");
                                distribution_quantity.val("0").trigger("change");
                            {% endif %}
                        }
                    });
                    {% endif %}
                    
                    // Hebdomadaire 4
                    {% if not distrib_unique and "hebdomadaire_4" in produit.frequences and inscriptions_frequences|get_item:"hebdomadaire_4"|length > 0 %}
                    {% if essai_gratuit or is_adherent %}
                    radio_hebdomadaire_4.change(() => {           
                        if(radio_hebdomadaire_4.prop("checked")) {
                            {% if inscription.id in inscriptions_frequences|get_item:"hebdomadaire_4" %}
                                distribution_quantity.val(Math.min(quantity.val(),{{ commande_max|mini:inscription.unites_restantes }})).trigger("change");
                            {% else %}
                                distribution_quantity.val("0").trigger("change"); 
                            {% endif %}
                            distribution_quantity_li.removeClass("d-none");
                        }
                    });
                    {% endif %}
                    {% endif %}

                    // Hebdomadaire Semestre
                    {% if not distrib_unique and "hebdomadaire_semestre" in produit.frequences and inscriptions_frequences|get_item:"hebdomadaire_semestre"|length > 0 %}
                    {% if is_adherent %}
                    radio_hebdomadaire_semestre.change(() => {
                        if(radio_hebdomadaire_semestre.prop("checked")) {
                            {% if inscription.id in inscriptions_frequences|get_item:"hebdomadaire_semestre" %}
                                distribution_quantity.val(Math.min(quantity.val(),{{ commande_max|mini:inscription.unites_restantes }})).trigger("change");
                            {% else %}
                                distribution_quantity.val("0").trigger("change");   
                            {% endif %}
                            distribution_quantity_li.removeClass("d-none");
                        }
                    });
                    {% endif %}
                    {% endif %}

                    // Bimensuelle 4
                    {% if not distrib_unique and "bimensuelle_4" in produit.frequences and inscriptions_frequences|get_item:"bimensuelle_4"|length > 0 %}
                    {% if essai_gratuit or is_adherent %}
                    radio_bimensuelle_4.change(() => {
                        if(radio_bimensuelle_4.prop("checked")) {
                            {% if inscription.id in inscriptions_frequences|get_item:"bimensuelle_4" %}
                                distribution_quantity.val(Math.min(quantity.val(),{{ commande_max|mini:inscription.unites_restantes }})).trigger("change");
                            {% else %}
                                distribution_quantity.val("0").trigger("change"); 
                            {% endif %}
                            distribution_quantity_li.removeClass("d-none");
                        }
                    });
                    {% endif %}
                    {% endif %}
                        
                    // Bimensuelle Semestre
                    {% if not distrib_unique and "bimensuelle_semestre" in produit.frequences and inscriptions_frequences|get_item:"bimensuelle_semestre"|length > 0 %}
                    {% if is_adherent %}
                    radio_bimensuelle_semestre.change(() => {
                        if(radio_bimensuelle_semestre.prop("checked")) {
                            {% if inscription.id in inscriptions_frequences|get_item:"bimensuelle_semestre" %}
                                distribution_quantity.val(Math.min(quantity.val(),{{ commande_max|mini:inscription.unites_restantes }})).trigger("change");
                            {% else %}
                                distribution_quantity.val("0").trigger("change");   
                            {% endif %}
                            distribution_quantity_li.removeClass("d-none");
                        }
                    });
                    {% endif %}
                    {% endif %}

                }
                {% endfor %}
                $( window ).on( "load", function() {
                    $(".produit-{{ produit.id }}-frequences:checked").trigger("change");
                });

                $(document).ready(() => {
                    let total_price = compute_total_price(
                        amount_inputs_ids_{{ produit.id }}, individual_prices_{{ produit.id }}
                    );
                    $("#produit_{{ produit.id }}_total").text(total_price.toFixed(2));
                    
                });
            }
            {% endwith %}
            {% endfor %}
        {% endfor %}
    </script>

{% endblock %}